﻿using UnityEngine;
using System.Collections;

public class ActionManager : MonoBehaviour
{
    public Transform bulletPrefab;
    public bool shoot = false;
    public float shootInterval = 0.2f;
    private Movement movement;
    private Transform transf;
    private float lastShootTime = 0;

    // Use this for initialization
    void Start()
    {
        movement = GetComponent<Movement>();
        transf = GetComponent<Transform>();
    }

    int shotCounter = 0;
    // Update is called once per frame
    void Update()
    {
        if (shoot)
        {
            if (Time.time - lastShootTime > shootInterval)
            {
                lastShootTime = Time.time;
                var angle = (movement.rotationAngle * Mathf.Rad2Deg) - 90;

                switch (shotCounter % 3)
                {
                    case 0:
                        angle += -3;
                        break;
                    case 1:
                        angle += 0;
                        break;
                    case 2:
                        angle += 3;
                        break;
                }

                //var angle = 0;
                var bulletTransf = GameObject.Instantiate(bulletPrefab) as Transform;
                var bullTran = bulletTransf.GetComponent<Movement>();
                bullTran.rotationAngle = movement.rotationAngle;
                bulletTransf.GetComponent<Bullet>().angle = angle;
                bullTran.Copy(movement);
                bullTran.effectiveRadius -= .2f;

                switch (shotCounter % 3)
                {
                    case 0:
                        bullTran.effectiveRadius -= .02f;
                        break;
                    case 1:
                        //bullTran.effectiveRadius -= .2f;
                        break;
                    case 2:
                        bullTran.effectiveRadius -= .02f;
                        break;
                }

                const float planarDistance = 2.6f;
                const float lateralDistance = 0.80f;
                bullTran.Translate(Mathf.Cos(angle * Mathf.Deg2Rad) * planarDistance, Mathf.Sin(angle * Mathf.Deg2Rad) * planarDistance);
                bullTran.Translate(Mathf.Cos(angle * Mathf.Deg2Rad + 90) * lateralDistance, Mathf.Sin(angle * Mathf.Deg2Rad + 90) * lateralDistance);

                const float recoilDistance = 0.2f;
                shotCounter++;
                if (shotCounter % 3 == 0)
                    movement.Translate(Mathf.Cos(angle * Mathf.Deg2Rad) * -recoilDistance, Mathf.Sin(angle * Mathf.Deg2Rad) * -recoilDistance);


            }
        }
    }
}
