﻿using UnityEngine;
using System.Collections;

public class Actor : MonoBehaviour
{
    public AudioClip hit, die;
    public bool isAlive = true;
    public int hp = 1;
    private AudioSource audioSource = null;

    void Start()
    {
        audioSource = GetComponent<AudioSource>();
    }

    public void DoDamage(int damage)
    {
        if (hit != null)
        {
            audioSource.clip = hit;
            audioSource.loop = false;
            audioSource.Play();
        }
        bool wasAlive = isAlive;
        hp = Mathf.Max(0, hp - damage);
        isAlive = hp != 0;
        if (wasAlive && !isAlive)
        {
            if (die != null)
            {
                audioSource.clip = die;
                audioSource.loop = false;
                audioSource.Play();
            }

            foreach(var audio in GetComponentsInChildren<AudioSource>())
            {
                if(audio != audioSource)
                {
                    Destroy(audio);
                }
            }

            //StartCoroutine(DisableComponents());
            GetComponent<Movement>().speed = 0;
        }
    }

    //private IEnumerator DisableComponents()
    //{
    //    yield return new WaitForSeconds(0.1f);
    //    //GetComponent<Collider>().enabled = false;
    //}
}
