﻿using UnityEngine;
using System.Collections;
using System.Linq;

public class AnimationManager : MonoBehaviour
{
    public AudioClip walk, die, kick;

    private Movement movement;
    Animator animator;
    private bool move = false;
    private bool shoot = false;
    private ActionManager actionManager = null;
    private AudioSource audioSource = null;
    public AudioSource shootAudioSource = null;
    public GameObject gameOverObject = null;
    public int cont = 0;
    // Use this for initialization
    void Start()
    {
        movement = GetComponent<Movement>();
        animator = gameObject.GetComponentInChildren<Animator>();
        actionManager = GetComponent<ActionManager>();
        audioSource = GetComponent<AudioSource>();
    }

    // Update is called once per frame
    void Update()
    {
        //if(movement) setta trigger else idle
        if ((movement.movementDirection.x != 0 || movement.movementDirection.y != 0) && !move)
        {
            move = true;
            animator.SetBool("Running", true);
            audioSource.clip = walk;
            audioSource.Play();
            audioSource.loop = true;
        }
        else if (movement.movementDirection.x == 0 && movement.movementDirection.y == 0 && move)
        {
            move = false;
            animator.SetBool("Running", false);
            audioSource.Stop();
        }
        if (actionManager.shoot && !shoot)
        {
            shoot = true;
            animator.SetTrigger("ShootStart");
            shootAudioSource.Play();
        }
        else if (!actionManager.shoot && shoot)
        {
            shoot = false;
            animator.SetTrigger("ShootEnd");
            shootAudioSource.Stop();
        }
    }
    void OnTriggerEnter(Collider collision)
    {
        //Debug.Log (collision.gameObject.name);
        if (cont == 0 && false)
        {
            cont++;
        }
        else
        {
            if (collision.GetComponent<Actor>().isAlive && movement.speed != 0)
            {
                animator.SetBool("isDie", true);
                audioSource.loop = false;
                audioSource.clip = die;
                audioSource.volume = 10;
                audioSource.Play();
                this.GetComponent<PlayerKeyboardController>().enabled = false;
                movement.speed = 0;
                gameOverObject.GetComponent<GUIText>().enabled = true;
            }
            else
            {
                if (!collision.GetComponent<Actor>().isAlive)
                {
                    audioSource.clip = kick;
                    audioSource.loop = false;
                    audioSource.Play();
                    animator.SetTrigger("Kick");
                    StartCoroutine(DisableComponents(collision.gameObject));
                }
            }
        }
    }

    private IEnumerator DisableComponents(GameObject obj)
    {
        yield return new WaitForSeconds(1f);
        Destroy(obj);
    }
}
