﻿using UnityEngine;
using System.Collections;

public class CupcakeSplit : MonoBehaviour
{
    public Transform cupcakeSplitPrefab;
    private Movement movement;
    private Actor actor;

    // Use this for initialization
    void Start()
    {
        actor = GetComponent<Actor>();
        movement = GetComponent<Movement>();
    }

    // Update is called once per frame
    void Update()
    {
        if (actor.isAlive == false)
        {
            Spawn(3, 3);
            Spawn(3, -3);
            Spawn(-3, -3);
            Spawn(-3, 3);
            //StartCoroutine(SpawnChildren());
            this.enabled = false;
        }
    }

    IEnumerator SpawnChildren()
    {
        yield return new WaitForSeconds(0.1f);
       
        Destroy(this.gameObject);
    }

    void Spawn(float lateralDistance, float planarDistance)
    {
        var cupcakeSplitTransf = GameObject.Instantiate(cupcakeSplitPrefab) as Transform;
        var cupcakeTran = cupcakeSplitTransf.GetComponent<Movement>();
        cupcakeTran.rotationAngle = movement.rotationAngle;
        var angle = (movement.rotationAngle * Mathf.Rad2Deg) - 90;
        cupcakeTran.Copy(movement);
        //const float planarDistance = 2.6f;
        cupcakeTran.Translate(Mathf.Cos(angle * Mathf.Deg2Rad) * planarDistance, Mathf.Sin(angle * Mathf.Deg2Rad) * planarDistance);
        cupcakeTran.Translate(Mathf.Cos(angle * Mathf.Deg2Rad + 90) * lateralDistance, Mathf.Sin(angle * Mathf.Deg2Rad + 90) * lateralDistance);
    }
}
