﻿using UnityEngine;
using System.Collections;

public class Damageable : MonoBehaviour
{
    public Transform explosionPrefab;
    private Actor actor = null;
    private Animator animator = null;
    private Movement movement = null;
    private float originalSpeed = 0;
    private float lastHitTime = 0;

    // Use this for initialization
    void Start()
    {
        actor = GetComponentInParent<Actor>();
        movement = GetComponent<Movement>();
        animator = gameObject.GetComponentInChildren<Animator>();
        originalSpeed = movement.speed;
    }

    void OnTriggerEnter(Collider collision)
    {
        if (collision.GetComponent<Actor>() == null && (collision.gameObject.name != "Character"))
        {
            lastHitTime = Time.time;
            movement.speed = 0;
            actor.DoDamage(1);
            if (actor.isAlive)
            {
                animator.SetTrigger("Hit");
                //Debug.Log("Collision enter Damageable" + Time.time + " " + collision.gameObject.name);
                (GameObject.Instantiate(explosionPrefab) as Transform).position = collision.transform.position;
                (GameObject.Instantiate(explosionPrefab) as Transform).rotation = collision.transform.rotation;
                Destroy(collision.gameObject);
            }
        }
    }

    // Update is called once per frame
    void Update()
    {
        if (Time.time - lastHitTime > 0.5 && actor.isAlive && originalSpeed != movement.speed)
        {
            movement.speed = originalSpeed;
        }
    }
}
